#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>
#include <map>
using namespace std;

int nax[40];
int need[40];
vector<int> trader[100];
int n;

__int128 encode(){
  __int128 res=0;
  for (int i=40; i--;){
    res=res*(nax[i]+1)+need[i];
  }
  return res;
}

int solve(int sum=-1){
  if (sum==-1) for (int i=sum=0; i<40; i++) sum+=need[i];
  if (sum==0) return 0;

  static map<__int128,int> memo;
  auto const key=encode();
  if (memo.count(key)) return memo[key];

  int res=sum;
  for (int i=n; i--;){
    int worst=0;
    for (auto x: trader[i]){
      if (not need[x]) {worst=sum;break;}
      need[x]--;
      worst=max(worst,solve(sum-1));
      need[x]++;
    }
    res=min(res,worst);
  }
  return memo[key]=res;
}

int main(){
  int b; cin>>b;
  for (int i=0; i<b; i++) cin>>need[i], nax[i]=need[i];
  cin>>n;
  for (int i=0; i<n; i++){
    int s; cin>>s; while (s--) trader[i].push_back(0), cin>>trader[i].back(), --trader[i].back();
  }
  cout<<solve()<<endl;
}
