#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
using namespace std;

int const maxn=1000000;

void fix(vector<pair<int,int>> &v){
  sort(v.begin(),v.end());
  for (int i=0,j=0; i<v.size(); i++){
    if (j and v[i].second<=v[j-1].second) v[j-1].second=v[i].second;
    else v[j++]=v[i];
  }
}

void solve(vector<pair<int,int>> *e,int n){
  if (n<=1) return;

  int best=(1<<30);
  for (int i=e[n-2].size(),j=e[n-1].size(); i--;){
    while (j and e[n-1][j-1].first>=e[n-2][i].second){
      best=min(best,e[n-1][--j].second);
    }
    e[n-2][i].second=best;
  }

  solve(e,n-1);
}

int main(){
  static vector<pair<int,int>> best[2][maxn];

  int n,m; cin>>n>>m;
  while (m--){
    int s,a,b,d; cin>>s>>a>>b>>d; --s;
    best[0][s].push_back({a,b});
    best[1][s].push_back({a+d,b+d});
  }
  for (int i=n; i--;)
    for (int j=2; j--;)
      fix(best[j][i]);

  solve(best[0],n-1);
  solve(best[1],n-1);

  int res=(n==1? 0: -1);
  int up=(1<<30);
  for (int i=best[0][0].size(),j=best[1][0].size(); i--;){
    while (j and best[1][0][j-1].first>=best[0][0][i].first){
      up=min(up,best[1][0][--j].second);
    }
    if (up>=best[0][0][i].second+30*60){
      res=best[0][0][i].first;
    }
  }
  if (res==-1) cout<<"impossible"<<endl;
  else cout<<res<<endl;
}
