#!/usr/bin/env python

n = int(raw_input())

#
# Worst case: 255 (prints 56 instructions)
#

asm = []

if n == 0:
    x = 0 ; asm += [['ZE', 'X']]
else:
    x = 1 ; asm += [['ST', 'X']]
    n -= 1
y = 1 ; asm += [['ST', 'Y']]
while n > 0:
    if n % 2 == 1:
        asm += [['PH', 'X']]
        asm += [['PH', 'Y' if x <> y else 'X']]
        asm += [['AD']]
        asm += [['PL', 'X']]
        x += y
    n /= 2
    if n > 0:
        asm += [['PH', 'Y' if x <> y else 'X']]
        asm += [['PH', 'Y' if x <> y else 'X']]
        asm += [['AD']]
        asm += [['PL', 'Y']]
        y += y
asm += [['DI', 'X']]

def never_used(asm):
    used = set()
    res = []
    ix = len(asm)
    while ix > 0:
        ix -= 1
        i = asm[ix]

        if i[0] == 'AD':
            res += [i]
        elif i[0] in ('PH', 'DI'):
            if i[0] == 'PH' and not (i[1] in used) and ix > 0 and asm[ix-1][0] == 'PL' and asm[ix-1][1] == i[1]:
                ix -= 1
                continue
            res += [i]
            used.add(i[1])
        elif i[1] in used:
            res += [i]
            used.remove(i[1])
    return res[::-1]

def mirrored_instructions(asm):
    res = []
    for i in asm:
        if i[0] == 'PL' and len(res) > 0 and res[-1][0] == 'PH' and i[1] == res[-1][1]:
            res = res[:-1]
            continue
        res += [i]
    return res

def sort_stack_ops(asm,dirn):
    res = asm[:]
    i = 0
    while i < len(res):
        if res[i][0] == 'PH':
            j = i+1
            while j < len(res) and res[i][0] == res[j][0]: j += 1
            res[i:j] = sorted(res[i:j])[::dirn]
            i = j
        if res[i][0] == 'PL':
            j = i+1
            while j < len(res) and res[i][0] == res[j][0]: j += 1
            res[i:j] = sorted(res[i:j])[::-dirn]
            i = j
        else:
            i += 1
    return res

last_iter = -1
while len(asm) <> last_iter:
    last_iter = len(asm)
    asm = never_used(asm)
    asm = sort_stack_ops(asm,+1)
    asm = mirrored_instructions(asm)
    asm = sort_stack_ops(asm,-1)
    asm = mirrored_instructions(asm)

for i in asm:
    print ' '.join(i)
