#!/usr/bin/env python
import sys

l = int(raw_input())
h = int(raw_input())
r,c = map(int, raw_input().split())

def calc_shape(cells):
    ans = [[0.0 for i in range(c)] for i in range(r)]
    for i in range(r):
        for j in range(c):
            for a in range(r):
                for b in range(c):
                    ans[i][j] += float(cells[a][b]) / ((i-a)**2+(j-b)**2+h**2)
            ans[i][j] = (ans[i][j] + 1e-20 >= l)
    return ans

def good(shape):
    for i in range(r):
        if shape[i][0] == False or shape[i][-1] == False: return False
    for i in range(c):
        if shape[0][i] == False or shape[-1][i] == False: return False
    return True

cells = map(lambda o: map(int, raw_input()[:c]), range(r))
if not good(calc_shape(cells)):
    print 'Not all border cells are sufficiently illuminated'
    sys.exit(1)

sys.exit(42)
