import java.util.Scanner;
import java.util.Arrays;

public class jwg {
	public static void main(String[] args) {
		int[] numbers = new int[10]; // all defaults to 0.

		Scanner in = new Scanner(System.in);

		String digits = in.nextLine();

		for (int i = 0; i < digits.length(); i++){
    		char c = digits.charAt(i);        
    		numbers[c-48]++; // 0 is ASCII 48.
		}
		// find the smallest, also keep track of the smallest digit we have at least one of,
		// so that if the smallest number is actually 0, we can use the smallest non-zero digit.
		Integer smallest_count = Integer.MAX_VALUE;
		Integer smallest_digit = null;
		Integer at_least_one = null;

		for (int j = 1; j < 10; ++j) {
			if (numbers[j] < smallest_count) {

				smallest_digit = j;
				smallest_count = numbers[j];
			}
			if (numbers[j] > 0 && at_least_one == null) {
				at_least_one = j;	
			}
		}
		char[] output;
		if (numbers[0] < smallest_count) {
			output = new char[numbers[0] + 1];
			Arrays.fill(output, '0');
			System.out.println(new StringBuilder().append((char)(48 + at_least_one)).append(new String(output)));	
		} else {
			output = new char[smallest_count + 1];
			Arrays.fill(output, (char) (48 + smallest_digit));
			System.out.println(new String(output));	
		}
	}
}