#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cmath>
using namespace std;
typedef long double ld;

uint16_t to[1001];

int main(){
  long long n; cin>>n;
  cout.precision(8);

  if (n>8){
    cout<<fixed<<1-1/M_E<<endl;
    return 0;
  }

  long long res=0,iters=0;
  for (int i=0; i<n; i++){
    to[i]=i;
  }
  do{
    bool ok=true;
    for (int i=0; i<n; i++) ok&=(to[i]!=i);
    res+=ok;
    ++iters;
  } while (next_permutation(to,to+n));
  cout<<fixed<<(iters-res)/(ld)(iters)<<endl;
}
