#!/usr/bin/env python3
import sys

MAX_B = 20
MAX_S = 1000000
MAX_F = 20
MAX_E = 1000000
MAX_M = 1000000

def main():
  B = int(input())
  assert 1 <= B <= MAX_B
  bands = [tuple(map(float, input().split())) for _ in range(B)]
  assert all(0 < s <= MAX_S for s, _ in bands), (min(bands), max(bands))
  assert all(0 <= p <= 100 for _, p in bands)
  P = float(input())
  assert 0 <= P <= 100
  F = int(input())
  assert 0 < F <= MAX_F, F

  for _ in range(F):
    e, m = map(float, input().split())
    assert 0 <= e <= MAX_E, e
    assert 0 <= m <= MAX_M, m

if __name__ == '__main__':
  main()
