#include <iostream>
#include <vector>
using namespace std;
typedef long double real;

real const eps=1e-8L;

int main(){
  cout.precision(8);

  int b; cin>>b;
  vector<pair<real,real>> band(b + 1);
  for (int i=0; i<b; i++) cin>>band[i].first>>band[i].second;
  band[b].first=1e60L; cin>>band[b].second;
  for (auto &i: band) i.second=1-i.second/100.L;

  int f; cin>>f;
  while (f--){
    real pre,post,from=0,to=0; cin>>pre>>post;
    vector<pair<real,real>> b=band;
    for (auto &i: b) {real diff=min(pre,i.first); pre-=diff, i.first-=diff;}
    for (auto it: b){
      if (to+it.first*it.second>=post){
        cout<<fixed<<from+(post-to)/it.second<<endl;
        break;
      }
      else{
        from+=it.first;
        to+=it.first*it.second;
      }
    }
  }
}
