#include <iostream>
#include <vector>
using namespace std;
typedef long double real;

real const eps=1e-8L;

struct Tax{real x,y,rate;};

real taxate(real from,vector<Tax> const &bands) {
  int lef=0;
  for (int r=(1<<30); r>>=1;){
    int mid=(lef+r);
    if (mid<bands.size() and bands[mid].x<=from) lef=mid;
  }
  return bands[lef].y+(from-bands[lef].x)*bands[lef].rate;
}

int main(){
  cout.precision(8);

  int b; cin>>b; b+=1; // Jim hack to get this working.
  vector<Tax> band(b);
  for (int i=0; i+1<b; i++) cin>>band[i+1].x>>band[i].rate; cin>>band[b-1].rate;
  for (int i=0; i<b; i++){
    band[i].rate=1-band[i].rate/100.L;
    if (i+1<b){
      band[i+1].y+=band[i].y+band[i+1].x*band[i].rate;
      band[i+1].x+=band[i].x;
    }
  }

  int f; cin>>f;
  while (f--){
    real pre,post; cin>>pre>>post;
    post+=taxate(pre,band);
    real lef=0.L,rgt=1e40L;
    for (int iter=200; iter--;){
      real mid=(lef+rgt)/2.L;
      (taxate(mid,band)<post? lef: rgt)=mid;
    }
    cout<<fixed<<lef-pre<<endl;
  }
}
