#!/usr/bin/env perl

use strict;
use warnings;
use List::Util qw(min);

my $beans = (1 + int rand 20);

my @have = (0) x $beans;
for my $i (1 .. (1 + int rand($beans * 100))) {
    my $id = int rand(1.7 * @have) % @have;
    $id = $#have - $id;
    if ($have[$id] < 100) {
      ++$have[$id];
    }
}
print "$beans\n";
print "@have\n";

my @good = map {min 100, $_} grep {$have[$_]} (0 .. $#have);
my $n = 1 + int rand 100;
print "$n\n";

for my $trader (1 .. $n) {
    my %trades = ();
    my $m = (1 + int rand $beans) * 2;
    for my $j (1 .. $m) {
        $trades{1 + $good[int rand @good]} = 1;
    }
    my @k = keys %trades;
    $m = @k;
    print "$m @k\n";
}
