#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>
#include <map>
using namespace std;

int beans;
int need[40];
vector<int> trader[240];
int n;

int32_t check(int64_t mask){
  for (int i=n; i--;){
    bool ok=false;
    for (auto j: trader[i]){
      if (mask&(1<<j)) ok=true;
    }
    if (not ok) return -1;
  }
  uint32_t res=0;
  for (int i=beans; i--;)
    if (!(mask&(1llu<<(int64_t)i)))
      res+=need[i];
  return res;
}

int main(){
  cin>>beans;
  for (int i=0; i<beans; i++) cin>>need[i];
  cin>>n;
  for (int i=0; i<n; i++){
    int s; cin>>s; while (s--) trader[i].push_back(0), cin>>trader[i].back(), --trader[i].back();
  }
  int32_t res=0;
  for (int64_t i=(1llu<<(int64_t)beans); i--;){
    res=max(res,check(i));
  }
  cout<<res<<endl;
}
