#include <iostream>
using namespace std;

int main(){

	int target; cin>>target;

	bool bit_set = false;
	// This doesn't always make the smallest number of instructions.
	// In the case of 2 for example. we should just ST A, PH A, PH A, AD, PL A, DI A.

	if (target == 0) {
		cout<<"ZE A\n"; // set a register to 0
	} else if (target == 1) {
		cout<<"ST A\n"; // set the register to 1.
	} else {
		cout<<"ST A\n"; // set the register to 1
		if ((target & 128) > 0) {
			// If the top bit is set, push it onto the stack, but don't double. 
			bit_set = true; 
			cout<<"PH A\n";
		}
		for (int i = 6; i > -1; i--) {
			if (bit_set == true) {
				// If at least one bit has already been set, double the value on the
				// stack (i.e. shift it to the right)
				cout<<"PL X\n";
				cout<<"PH X\n";
				cout<<"PH X\n";
				cout<<"AD\n";
			}

			if ((target & 1<<i) > 0) {
				// Now if the current bit is set, push a 1 on the stack.
				cout<<"PH A\n";
				if (bit_set == true) {
					// If it already had some values, add the bit on.
					cout<<"AD\n";
				}
				bit_set = true;
			}
		}
		cout<<"PL A\n"; // pull the value on the stack into A for printing.
	}
	cout<<"DI A\n"; // output.
}