#!/usr/bin/env python
from random import randint,uniform
from sys import stdout

l = randint(3,6)
print l

h = randint(1,5)
print h

r = 30
c = 28
print r,c

def calc_shape(cells):
    ans = [[0.0 for i in range(c)] for i in range(r)]
    for i in range(r):
        for j in range(c):
            for a in range(r):
                for b in range(c):
                    ans[i][j] += float(cells[a][b]) / ((i-a)**2+(j-b)**2+h**2)
            ans[i][j] = (ans[i][j] + 1e-20 >= l)
    return ans

def good(shape):
    for i in range(r):
        if shape[i][0] == False or shape[i][-1] == False: return False
    for i in range(c):
        if shape[0][i] == False or shape[-1][i] == False: return False
    return True

cells = [[0 for i in range(c)] for i in range(r)]
while not good(calc_shape(cells)):
    for z in range(randint(1, 100)):
        a = randint(-20,r-1+20)
        b = randint(-20,c-1+20)
        a = max(0,min(r-1,a))
        b = max(0,min(c-1,b))
        cells[a][b] = min(9, int(cells[a][b] + (1+uniform(1,20)**0.5)))

for i in range(r):
    for j in range(c):
        stdout.write('%1d' % cells[i][j])
    stdout.write('\n')

