#!/usr/bin/env perl

use strict;
use warnings;

sub shuffle {
    my %tmp = map {rand 1 => $_} @_;
    return map {$tmp{$_}} sort keys %tmp;
}

my @res = ();
for my $digit (0 .. 9) {
    my $cnt = int rand 10001;
    push @res, ($digit) x $cnt;
}
@res = shuffle @res;

my $n = 1000;
@res = @res[0 .. $n-1];

$" = '';
print "@res\n";
