#include <bits/stdc++.h>
using namespace std;

int N, T, G;
int X[500];

int cost1[500][500]{};

int Cost1(int i0, int i1) {
  i0 %= N;
  if ((i1 - i0 + N) % N == 1) return 0;
  int &ret = cost1[i0 % N][i1 % N];
  if (!ret) ret = 1 + Cost1(i0+1, i1) + (X[i1] - X[(i0+1)%N] + T) % T;
  return ret - 1;
}

int tcost1[500][500], tcost[500][500], ncost[500][500];
int idx[500], NN = 0; // #unique X's

int solve() {
  if (G >= NN) return 0;
  int ans = 1<<20;
  for (int i = 0; i < NN; ++i)
    for (int j = 0; j < NN; ++j)
      tcost1[i][j] = Cost1(idx[i], idx[j]);
  for (int i = 0; i < NN; ++i)
    for (int j = 0; j < NN; ++j)
      tcost[i][j] = 1<<20;
  for (int g = 0; g < G; ++g) {
    for (int i = 0; i < NN; ++i)
      for (int j = 0; j < NN; ++j) {
	int v = min(tcost1[i][j], tcost[i][j]);
	for (int k = 1; (i+k) % NN != j; ++k) {
	  int c1 = tcost1[i][(i+k)%NN];
	  if (c1 >= v) break; // optimize by breaking early
	  v = min(v, c1 + tcost[(i+k)%NN][j]);
	}
	ncost[i][j] = v;
      }
    memcpy(tcost, ncost, sizeof(tcost));
  }
  for (int i = 0; i < NN; ++i)
    ans = min(ans, tcost[i][i]);
  return ans;
}

int main(void) {
  scanf("%d%d%d", &N, &T, &G);
  T *= 2;
  for (int i = 0; i < N; ++i)
    scanf("%d", X+i), X[i] %= T;
  sort(X, X+N);
  NN = 0;
  for (int i = 0; i < N; ++i)
    if (i == N-1 || X[i] != X[i+1]) idx[NN++] = i;
  printf("%d\n", solve());
  return 0;
}
