#include <algorithm>
#include <iostream>
using namespace std;

int dp[501][501];

int main(){
    int n,distance,gondolas; cin>>n>>distance>>gondolas;
    int modulus=distance*2;
    int res=n*modulus;

    static int when[501];
    for (int i=n; i--;) cin>>when[i], when[i]%=modulus;
    sort(when,when+n);

    for (int q=n; q--;){
        for (int i=0; i<=gondolas; i++)
            for (int j=n; j--;)
                dp[i][j]=1<<28;

        dp[1][n-1]=0;
        for (int i=0; i<n; i++){
            dp[1][n-1]+=when[n-1]-when[i];
        }

        for (int i=1; i<=gondolas; i++){
            dp[i][n-1]=dp[1][n-1];

            for (int t=n; t--;){
                for (int s=t; s--;){
                    dp[i][s]=min(dp[i][s], dp[i-1][t]+(when[s]-when[t])*(s+1));
                }
            }
        }

        for (int i=1; i<=gondolas; i++)
            for (int j=n; j--;)
                res=min(res,dp[i][j]);

        // rotate array
        {int z=when[0]; for (int i=0; i+1<n; i++) when[i]=when[i+1]; when[n-1]=z+modulus;}
    }
    cout<<res<<endl;
}
