#include <bits/stdc++.h>
using namespace std;

int N, T, G;
int X[500];
int F;

int cost1[500][500]{};

int Cost1(int i0, int i1) {
  i0 %= N;
  if ((i1 - i0 + N) % N == 1) return 0;
  int &ret = cost1[i0 % N][i1 % N];
  if (!ret) ret = 1 + Cost1(i0+1, i1) + (X[i1] - X[(i0+1)%N] + T) % T;
  return ret - 1;
}

int idx[500], uniq = 0;

int solve1() {
  random_shuffle(idx, idx+uniq);
  set<int> chosen;
  for (int i = 0; i < G; ++i)
    chosen.insert(idx[i]);
  int prev = *--chosen.end(), C = 0;
  for (auto v: chosen) {
    C += Cost1(prev, v);
    prev = v;
  }

  for (int iter = 0; iter < 100000; ++iter) {
    int a = random() % G;
    int b = G + random() % (uniq-G);

    auto at_a = chosen.find(idx[a]);
    auto before_a = at_a, after_a = at_a;
    if (before_a == chosen.begin()) before_a = --chosen.end();
    else --before_a;
    ++after_a;
    if (after_a == chosen.end()) after_a = chosen.begin();
    int loss = Cost1(*before_a, *after_a) - Cost1(*before_a, *at_a) - Cost1(*at_a, *after_a);
    chosen.erase(at_a);
    
    auto after_b = chosen.upper_bound(idx[b]), before_b = after_b;
    if (after_b == chosen.end()) {
      after_b = chosen.begin();
    }
    if (before_b == chosen.begin()) {
      before_b = --chosen.end();
    } else {
      --before_b;
    }
    int gain = Cost1(*before_b, *after_b) - Cost1(*before_b, idx[b]) - Cost1(idx[b], *after_b);

    if (gain > loss) {
      chosen.insert(idx[b]);
      swap(idx[a], idx[b]);
      C -= gain - loss;
    } else {
      chosen.insert(idx[a]);
    }
  }
  return C;
}

int solve() {
  if (G >= N) return 0;
  int ans = 1<<20;
  if (G == 1) {
    for (int i = 0; i < uniq; ++i)
      ans = min(ans, Cost1(idx[i], idx[i]));
    return ans;
  }
  for (int i = 0; i < 30; ++i) ans = min(ans, solve1());
  return ans;
}

int main(void) {
  scanf("%d%d%d", &N, &T, &G);
  T *= 2;
  for (int i = 0; i < N; ++i)
    scanf("%d", X+i), X[i] %= T;
  sort(X, X+N);
  uniq = 0;
  for (int i = 0; i < N; ++i)
    if (i == N-1 || X[i] != X[i+1]) idx[uniq++] = i;
  printf("%d\n", solve());
  return 0;
}
