#include <iostream>
#include <cstdlib>
#include <cmath>
using namespace std;

typedef long double ld;
int to[1001];

int main(){
  cout.precision(8);
  int n; cin>>n;
  srand(777);

  if (n>8){
    cout<<fixed<<1-1/M_E<<endl;
  }

  ld res=0.L;
  int trials=2000000;
  for (int i=0; i<n; i++){
    to[i]=i;
  }
  for (int i=0; i<trials; i++){
    bool ok=true;
    for (int j=n; j--;){
      swap(to[j],to[rand()%(j+1)]);
      ok&=(to[j]!=j);
    }
    res+=not ok;
  }

  cout<<fixed<<(res/trials)<<endl;
}
